var express		= require('express');
var router		= express.Router();

var Product		= require('./../models/product');
var md5			= require('MD5');
var auth		= require('./../modules/auth.js');
var bodyParser	= require('body-parser');

router.use(bodyParser.urlencoded({ extended: true })); 
router.use(bodyParser.json()); 

router.route('/list')
	.get(auth, function(request, response) {
		Product
			.find({})
			.populate('image')
			.exec(function(err, res) {
				response.status(200).json(res);
			});
	});

router.route('/:id')
	.get(auth, function(request, response) {
		Product
			.findById(request.params.id)
			.populate('image')
			.exec(function(err, res) {
				response.status(200).json(res);
			});
	});

router.route('/create')
	.post(auth, function(request, response) {
		var product	= new Product(request.body);
		product.validate(function(err) {
			if (err)
				response.sendStatus(500);
			else	{					
				product.save(function() {
					response.status(200).json(product);	
				});
			}
		});
	});

router.route('/del')
	.post(auth, function(request, response) {		
		Product			
			.findById(request.body._id)
			.exec(function(err, res) {
				res.remove(function() {
					response.sendStatus(200);
				});
			});
	});

router.route('/edit')
	.post(auth, function(request, response) {
		Product.
			findByIdAndUpdate(request.body._id, request.body)
			.exec(function(err, product) {
				response.sendStatus(200);
			});
	});

module.exports	= router;
